First flash of OpenWrt:

- Resources are found at https://openwrt.org/toh/tp-link/td-w8970_v1
- Our V1 board version needs serial to boot reliably. Grab an FTDI232 USB to serial converter, follow the guide here https://openwrt.org/toh/tp-link/td-w8970_v1#serial to solder wires from GND to GND, RX to TX and TX to RX, make sure the 3.3V option is selected using the appropriate jumper on the serial converter. 
- Plug the serial converter in your PC, from now on, I'll assume you're using a systemd linux distro.
- open a terminal and type "screen /dev/ttyUSB0 115200"
- a blank shell will open, now plug in the TPLINK's power brick and hit "t" repeatedly to stop boot (if you see nothing, or garbled characters, check serial connection and baudrate).
- You should now see a shell similar to this: 
	ROM VER: 1.1.4
	CFG 05
	EEPROM Data OK
	UART
	
	VR9 #
- download the .bin sysupgrade file and follow the commands at the first link, and remember to change the name of the .bin file to the one you downloaded:
- WARNING! if at any step you get a message saying "unknown command setenv" or similar, DO NOT switch off the TPLINK, just unplug the serial converter from yout USB, plug it back in and start "screen" again. You should be able to continue where you left off.
setenv ipaddr 192.168.1.1
setenv serverip 192.168.1.2
setenv bootargs 'board=WD8970'
tftpboot 0x81000000 openwrt-CHANGE-THIS-TO-CURRENT-VERSION-lantiq-xrx200-tplink_tdw8970-squashfs-sysupgrade.bin

- you will now get a message saying that the board is waiting for a file to be uploaded via TFTP
- plug in an ethernet cable from your PC to port 1 of the TPLINK, open your PC's network settings, disable DHCP for ethernet and manually set the IP to 192.168.1.2 (netmask 255.255.255.0 and gateway 192.168.1.1). You can verify the settings by typing "ip addr" in a terminal.
- if you do not have TFTP on your PC, install tftp-hpa with your packet manager and then start the server with:
systemctl start tftpd.service
- now open the folder "/srv/tftp/" as root and copy the downloaded .bin file in it (you can do this with "sudo cp" + the paths you need, or by using a root file explorer)
- the upload should automatically start and you should see it progressing via serial.
- now continue following the given commands to erase and write the flash over serial:
sf erase 0x20000 0x7a0000
sf write 0x81000000 0x20000 0x$(filesize)
- check carefully for errors, if anything fails, DO NOT power-cycle the board, try to repeat steps and unplugging-replugging the FTDI adapter. If the board looses power now, you will need a CH341 programmer to manually re-flash the SPI flash.
- if everything went well, reboot:
reset

- You should now be greeted by an OpedWrt shell over your serial console. Use it to set your desired password for the root user.
- You should now be able to access your LUCI web interface at 192.168.1.1

ENJOY!